{
  RealThinClient W/A Framework: Client-side DataModule implementation
  Copyright (c) Danijel Tkalcec 

  @exclude
}
unit rtc_DataModuleCli;

{$include rtcDefs.inc}

interface

uses
  SysUtils, Classes,
  rtcInfo, rtcLog,

  rtcBaseCli;

type
  TrtcDataModuleC=class(TRtcBaseDataModuleC)
  protected
    function _Process(const xName:string; xData:TRtcValue):boolean; override;
    function _SetEvent(const xName:string; xID:longint):boolean; override;

  public
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
    end;

implementation

{$ifndef FPC}
  {$R *.dfm}
{$endif}

constructor TrtcDataModuleC.Create(AOwner: TComponent);
  begin
  inherited;
  end;

destructor TrtcDataModuleC.Destroy;
  begin
  inherited;
  end;

function TrtcDataModuleC._Process(const xName: string; xData: TRtcValue):boolean;
  begin
  Result:=True;
  if not inherited _Process(xName,xData) then
    begin
    Result:=False;
    Log('DataModule property: '+xName+' = '+String(xData.toCode));
    end;
  end;

function TrtcDataModuleC._SetEvent(const xName: string; xID: Integer):boolean;
  begin
  Result:=True;
  if not inherited _SetEvent(xName,xID) then
    begin
    Result:=False;
    Log('Event: '+xName+' = '+IntToStr(xID));
    end;
  end;

initialization
RegisterClass(TrtcDataModuleC);
finalization
UnRegisterClass(TrtcDataModuleC);
end.
